package extensions;

import java.io.IOException;
import java.net.Socket;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

//import dareka.extensions.Extension2;
//import dareka.extensions.ExtensionManager;
import dareka.processor.HttpRequestHeader;
import dareka.processor.Processor;
import dareka.processor.Resource;
import dareka.processor.URLResourceCache;

public class VideoArrayCache implements Processor/*,Extension2*/ {
	
//	private static final String LOG_PREFIX = "VACache";
//	private static final String PROP_DEBUG = "VACacheDebug";
//	private static ExtUtil util = null;
	private static final String[] SUPPORTED_METHODS = new String[] { "GET" };
	private static final Pattern VIDEO_ARRAY_URL_PATTERN = Pattern.compile("^(http://i\\.nicovideo\\.jp/v3/video\\.array)(.*)$");
	
	private static final URLResourceCache resources = new URLResourceCache("cacheVideoArrayMax", "cacheVideoArrayExpire");
	
	public String[] getSupportedMethods() {
		return SUPPORTED_METHODS;
	}
	
	public Pattern getSupportedURLAsPattern() {
		return VIDEO_ARRAY_URL_PATTERN;
	}
/*	
	public String getVersionString() {
		return "VideoArrayCache test";
	}
	
	public void registerExtensions(ExtensionManager mgr) {
		if( util == null ) {
			util = new ExtUtil(this, LOG_PREFIX, PROP_DEBUG);
		}
		mgr.registerProcessor(this);      // Processorとして登録
	}
*/
	public String getSupportedURLAsString() {
		return null;
	}
	
	protected void finalize() {
		// GCの時にでも全てのキャッシュをExpire処理してメモリを有効活用
		resources.expires();
	}
	
	public Resource onRequest(HttpRequestHeader requestHeader, Socket browser)
	throws IOException {
		String uri = requestHeader.getURI();
		Matcher m = VIDEO_ARRAY_URL_PATTERN.matcher(uri);
//		util.info(uri);
		if (!m.matches()) {
			Resource.get(Resource.Type.URL, uri);
		}
//		util.info(m.group(1));
//		util.info(m.group(2));
		return resources.cacheAndRewrite(m.group(2), null, requestHeader);
	}
	
}
